ChampionDumper = {}

ChampionDumper.name = "ChampionDumper"
ChampionDumper.savedData = {}

function ChampionDumper:Initialize()
    -- Do some init stuff
    ChampionDumper.savedData = ZO_SavedVars:NewAccountWide('ChampionDumperSavedVariables', 1, nil, systemDefault, nil, 'ChampionDumper')

    -- wait 10 seconds or so before we begin dumping so we don't do it right when we load in
    zo_callLater(function()
        CHAT_ROUTER:AddSystemMessage("ChampionDumper starting")

        if not ChampionDumper.savedData then
            ChampionDumper.savedData = {}
        end

        for k in pairs(ChampionDumper.savedData) do
            ChampionDumper.savedData[k] = nil
        end

        for disciplineIndex = 1, GetNumChampionDisciplines() do
            ChampionDumper.savedData[disciplineIndex] = {}
            ChampionDumper.savedData[disciplineIndex]["name"] = GetChampionDisciplineName(disciplineIndex)
            for skillIndex = 1, GetNumChampionDisciplineSkills(disciplineIndex) do
                local skillId = GetChampionSkillId(disciplineIndex, skillIndex)
                if not ChampionDumper.savedData[disciplineIndex][skillId] then
                    ChampionDumper.savedData[disciplineIndex][skillId] = {}
                end
                ChampionDumper.savedData[disciplineIndex][skillId]["name"] = GetChampionSkillName(skillId)
                if GetChampionSkillJumpPoints(skillId) then
                    ChampionDumper.savedData[disciplineIndex][skillId]["jumpPoints"] = {GetChampionSkillJumpPoints(skillId)}
                end
                ChampionDumper.savedData[disciplineIndex][skillId]["maxPoints"] = GetChampionSkillMaxPoints(skillId)
                ChampionDumper.savedData[disciplineIndex][skillId]["skillType"] = GetChampionSkillType(skillId)
                if GetChampionSkillType(skillId) == CHAMPION_SKILL_TYPE_NORMAL then
                    ChampionDumper.savedData[disciplineIndex][skillId]["slottable"] = false
                else
                    ChampionDumper.savedData[disciplineIndex][skillId]["slottable"] = true
                end
                if not ChampionDumper.savedData[disciplineIndex][skillId]["intervals"] then
                    ChampionDumper.savedData[disciplineIndex][skillId]["intervals"] = {}
                end
                local prevDescription = ""
                local prevBonus = ""
                if GetChampionSkillJumpPoints(skillId) then
                    for k, v in pairs(ChampionDumper.savedData[disciplineIndex][skillId]["jumpPoints"]) do
                        if prevDescription ~= GetChampionSkillDescription(skillId, v) then
                            if not ChampionDumper.savedData[disciplineIndex][skillId]["intervals"][v] then
                                ChampionDumper.savedData[disciplineIndex][skillId]["intervals"][v] = {}
                            end
                            ChampionDumper.savedData[disciplineIndex][skillId]["intervals"][v]["description"] = GetChampionSkillDescription(skillId, v)
                            ChampionDumper.savedData[disciplineIndex][skillId]["intervals"][v]["bonusText"] = GetChampionSkillCurrentBonusText(skillId, v)
                        end
                    end
                else
                    for i = 0, ChampionDumper.savedData[disciplineIndex][skillId]["maxPoints"], 1 do
                        if prevDescription ~= GetChampionSkillDescription(skillId, i) or prevBonus ~= GetChampionSkillCurrentBonusText(skillId, i) then
                            if not ChampionDumper.savedData[disciplineIndex][skillId]["intervals"][i] then
                                ChampionDumper.savedData[disciplineIndex][skillId]["intervals"][i] = {}
                            end
                            prevDescription = GetChampionSkillDescription(skillId, i)
                            prevBonus = GetChampionSkillCurrentBonusText(skillId, i)
                            ChampionDumper.savedData[disciplineIndex][skillId]["intervals"][i]["description"] = prevDescription
                            ChampionDumper.savedData[disciplineIndex][skillId]["intervals"][i]["bonusText"] = prevBonus
                        end
                    end
                end
            end
        end

        CHAT_ROUTER:AddSystemMessage("ChampionDumper finished")
    end, 8500)
end

function ChampionDumper.OnAddOnLoaded(event, addonName)
    if addonName == ChampionDumper.name then
        ChampionDumper:Initialize()
    end
end

EVENT_MANAGER:RegisterForEvent(ChampionDumper.name, EVENT_ADD_ON_LOADED, ChampionDumper.OnAddOnLoaded)